c**********************************************************************

      subroutine figures(n,bp_S,q,qt_S,knot_S,
     &     m_tc,mt_tc,mr_tc,n_tc,nr_tc,knot_tc,xchims_tc,q_ppt,
     &     a1,j2,j4,j6,j8,
     &     etat,opa,conv,nuc)
c     Version: 00/00/03
c-Entrees:
c     n: nombre de couches
c     bp_S,q,qt_S,knot_S: coefficients de splines caracterisant le modele
c     m_tc,mt_tc,mr_tc,n_tc,nr_tc,knot_tc,xchims_tc: coefficients de spline
c         pour calcul de la composition chimique
c     q_ppt(2): position de la ppt (q_ppt(1)<q_ppt<q_ppt(2))
c     splines pour la composition chimique
c-Sorties:
c     a1: rayon equatorial
c     j2,j4,j6,j8: moments gravitationnels 
c     COMMON(s) /figures_i/ et /figures_r/: contiennent les coefficients
c     de spline pour le calcul du potentiel centrifuge d'ordre >0
c     (utilise dans EQUATIONS)
c-Subroutines externes:
c     etat,opa,conv,nuc
      
      implicit none
      
      include './cepam.inc'
      integer pspl,pjac,pspl_n,pjac_n,pdxt_n,pn_d,pn_f
      parameter (pspl=pm_S*(pn-1)+pr_S, pjac=pne*pspl,
     &     pspl_n=pm_S*(pn_noy-1)+1, pjac_n=pne_noy*pspl_n,
     &     pdxt_n=pm_S*pn_noy+2*pr_S, pn_d=pn+pn_noy+pndis,
     &     pn_f=pn+pn_noy)
      
      integer n,knot_S,n_tc,nr_tc,knot_tc,nea,m_n_S,r_n_S,nb,knot_n_S
      real*8 bp_S(pjac),q(pn),qt_S(pn),m_tc(1),mt_tc(1),mr_tc(1),
     &     xchims_tc(1),bp_n_S(pjac_n),mass_n(pdxt_n),
     &     mass_n_S(pn_noy*pm_S+2),q_ppt(2)
      
      integer nd_f,nx_f,m_f,nr_f,knot_f,id_f(0:pndis+1)
      real*8 x_f(pn_f),xt_f(pn_f+pmc_S*(pndis+2)),xr_f(pn_f),
     &     s_f(pn_d*pmc_S*2),pot_f(2,pn_d),
     &     pot_fd(2,pndis),rplanet
      common/figures_i/nd_f,nx_f,m_f,nr_f,knot_f,id_f
      common/figures_r/x_f,xt_f,xr_f,pot_f,s_f,rplanet
      data m_f/3/
      
      integer i,j,ll,idisc_n(pndis),idisc(pndis),n_d,n_noy,ndis
      real*8 p(pn),t(pn),r(pn),l(pn),m(pn),xchim(pnelem),
     &     dxchim(pnelem),dxchimm(pnelem),lnp_S(pspl),lnt_S(pspl),
     &     r2_S(pspl),l23_S(pspl),mu_S(pspl),y(5),dy(5),ddy(5,5),
     &     ro(pn),dror(pn),chim(pn),chim_dis(pndis),
     &     p_dis(pndis),t_dis(pndis),r_dis(pndis),
     &     l_dis(pndis),m_dis(pndis),ro_dis(pndis),dror_dis(pndis),
     &     p_n(pn_noy),r_n(pn_noy),m_n(pn_noy),ro_n(pn_noy),
     &     dror_n(pn_noy),deltaro(pndis),
     &     m_d(pn_d),r_d(pn_d),p_d(pn_d),t_d(pn_d),l_d(pn_d),ro_d(pn_d),
     &     dror_d(pn_d),b(pn_d),h(pn_d),unpdx(2),chim_d(pn_d)
      real*8 drop,drot,drom,tds,dtdsp,dtdst,dtdsl,dtdsm,mm,
     &     bid,mnoyau1,p_ice1,omega1,a1,j2,j4,j6,j8,romoy
      integer*4 leng
      real*8 interq
      
      include './Communs/ctephys.inc'
      include './Communs/planetes.inc'
      include './Communs/modelp.inc'
      
      character*31 nom_fich1,nom_fich2
      common/in_out/nom_fich1,nom_fich2
      
      external etat,opa,conv,nuc
      
c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
 2000 format(1p8d10.3)
      
      unpdx(1)=1.d0-1.d-5
      unpdx(2)=1.d0+1.d-5
      tds=0.
      dtdsp=0.
      dtdsl=0.
      dtdsm=0.

c     write(*,*)'FIGURES: m,r,p,t,ro,dror,dror(lineaire)'

c---- Recuperation de l'enveloppe ----------------------------------      
      do i=1,n
       y(1)=bp_S(ne*(i-1)*m_S+1)
       p(i)=exp(y(1))
       y(2)=bp_S(ne*(i-1)*m_S+2)
       t(i)=exp(y(2))
       if(en_masse)then
        y(3)=bp_S(ne*(i-1)*m_S+3)
        r(i)=sqrt(abs(y(3)))
        y(4)=bp_S(ne*(i-1)*m_S+4)
        l(i)=sqrt(abs(y(4)))**3
        y(5)=bp_S(ne*(i-1)*m_S+5)
        m(i)=sqrt(abs(1.d0-y(5)))**3
       else
        pause 'revoir le modele en rayon'
        y(3)=bp_S(ne*(i-1)*m_S+3)
        r(i)=y(3)
        y(4)=bp_S(ne*(i-1)*m_S+4)
        l(i)=y(4)
        y(5)=bp_S(ne*(i-1)*m_S+5)
        m(i)=y(5)
       endif
       
       call pp1dn(nbelem,m_tc,mt_tc,mr_tc,n_tc,nr_tc,mc_S,1.d0-m(i),
     &      knot_tc,ll,dxchim,bid,xchims_tc,xchim,.true.)
       do j=1,nbelem
c        xchim(j)=xchim(j)*nucleo(j)
        dxchimm(j)=-dxchim(j)
       enddo
       chim(i)=xchim(1)
       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Pour eviter le probleme au centre lorsque Mnoyau=0               c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if ((y(3).le.0.).or.(y(5).ge.1.d0)) then
        y(3)=1d-6
        y(5)=1-sqrt(4/3.d0*pi*ro(i-1))**3*y(3)
       endif
        
       call equations(0,y,xchim,dxchimm,.false.,tds,dtdsp,dtdst,
     &      dtdsm,dy,ddy,ro(i),drop,drot,drom,
     &      etat,opa,conv,nuc)
       
       dror(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r(i)/dy(3)
c       if (i.gt.1) vdror=(ro(i-1)-ro(i))/(r(i-1)-r(i))

c       write(*,2000)m(i),r(i),p(i),t(i),ro(i),dror(i),vdror,drom
      enddo
      
c      write(*,*)'FIGURES: rjup=',rjup,' r(1)=',r(1)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c---- Si PPT recherche de la transition ----------------------------   c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (ppt) then
       do i=1,(n-1)*m_S+r_S       !modele au temps t
        lnp_S(i)=bp_S(ne*(i-1)+1)
        lnt_S(i)=bp_S(ne*(i-1)+2)
        r2_S(i) =bp_S(ne*(i-1)+3)
        l23_S(i)=bp_S(ne*(i-1)+4)
        mu_S(i)=bp_S(ne*(i-1)+5)
       enddo
       
c       write(*,*)'Localisation PPT: ',q_ppt(1),'< q_ppt < ',q_ppt(2)
c       call dis_ppt(lnp_S,lnt_S,q,qt_S,m_S,r_S,knot_S,n,q_ppt(1),q_ppt(2))
c       write(*,*)'Localisation PPT: ',q_ppt(1),'< q_ppt < ',q_ppt(2)
       
       do i=1,2
        y(1)=interq(lnp_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
     &       +(2*i-3)*1.d-3
        p_dis(i)=exp(y(1))
        y(2)=interq(lnt_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        t_dis(i)=exp(y(2))
        y(3)=interq(r2_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        r_dis(i)=sqrt(abs(y(3)))
        y(4)=interq(l23_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        l_dis(i)=sqrt(abs(y(4)))**3
        y(5)=interq(mu_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        m_dis(i)=sqrt(abs(1.d0-y(5)))**3

c     On utilise la table de composition splinee en se placant aux couches
c     q_ppt-1 et q_ppt+1 afin d'eviter tout probleme.
        call pp1dn(nbelem,m_tc,mt_tc,mr_tc,n_tc,nr_tc,mc_S,
     &       1.d0-m(nint(q_ppt(1))+2*i-3),
     &       knot_tc,ll,dxchim,bid,xchims_tc,xchim,.true.)
        chim_dis(i)=xchim(1)
c        write(*,*)'FIGURES: chim=',chim_dis(i)
        
        call equations(0,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &       dtdsm,dy,ddy,ro_dis(i),drop,drot,drom,
     &       etat,opa,conv,nuc)
        
        dror_dis(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r_dis(i)/dy(3)
        
c        write(*,*)'PPT:'
c        write(*,2000)m_dis(i),r_dis(i),p_dis(i),t_dis(i),ro_dis(i),
c     &       dror_dis(i),drom
c        write(*,*)
       enddo
       r_dis(1)=r_dis(2)
      else
       q_ppt(1)=dble(n+1)
      endif		!PPT

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c---- Reconstruction du noyau ---------------------------------------  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (mnoyau.ne.0.) then
c       write(*,*)'modele=',nom_fich2(:leng(nom_fich2))//'_n.bin'
       open(unit=33,form='unformatted',status='old',
     &     file=nom_fich2(:leng(nom_fich2))//'_n.bin',err=233)
       read(33)mnoyau1,p_ice1,omega1,nb,m_n_S,r_n_S,nea,knot_n_S,
     &      bp_n_S,mass_n,mass_n_S
       close(unit=33)
       goto 234

 233   write(*,*)'Le fichier ',nom_fich2(:leng(nom_fich2))//'_n.bin',
     &      ' n''existe pas'
       write(*,*)'-> PAS DE CALCUL DES MOMENTS GRAVITATIONNELS'
       return

 234   continue
c       if ((mnoyau.ne.mnoyau1).or.(p_ice.ne.p_ice1).or.
c     &      (omega.ne.omega1)) write(*,2340)mnoyau,p_ice,omega,
c     &      mnoyau1,p_ice1,omega1
 2340  format('Figures: Attention le noyau a change/',
     &      ' mnoyau,p_ice,omega,',/,10x,1p3d15.8,/,10x,1p3d15.8)

       j=0
       idisc_n(1)=0
       if ((p_ice.lt.0.0001).or.(p_ice.gt.0.9999)) then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Pas de discontinuite dans le noyau (ROCHES ou GLACES)            c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        do i=1,nb
         y(1)=bp_n_S(nea*(i-1)*m_n_S+1)
         p_n(i)=exp(y(1))
         y(2)=1.d0
         y(3)=bp_n_S(nea*(i-1)*m_n_S+2)
         r_n(i)=sqrt(abs(y(3)))
         y(4)=0.d0
         y(5)=1.d0-mass_n(i)
         m_n(i)=sqrt(abs(mass_n(i)))**3
         call equations(2,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &        dtdsm,dy,ddy,ro_n(i),drop,drot,drom,
     &        etat,opa,conv,nuc)
         dror_n(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r_n(i)/dy(3)
        enddo
        n_noy=nb
       else
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     DISCONTINUITE ROCHE/GLACES DANS LE NOYAU                         c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        mnoyau1=((1.d0-p_ice)*mnoyau)**(2/3.d0) !mnoyau1 =masse de roches
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Roches                                                           c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        i=1
        if (1.d0-p_ice.gt.1d-12) then
         do while ((i.le.nb).and.(mass_n(i).le.mnoyau1))
          y(1)=bp_n_S(nea*(i-1)*m_n_S+1)
          p_n(i)=exp(y(1))
          y(2)=1.d0
          y(3)=bp_n_S(nea*(i-1)*m_n_S+2)
          r_n(i)=sqrt(abs(y(3)))
          y(4)=0.d0
          y(5)=1.d0-mass_n(i)
          m_n(i)=sqrt(abs(mass_n(i)))**3
          call equations(2,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &         dtdsm,dy,ddy,ro_n(i),drop,drot,drom,
     &         etat,opa,conv,nuc)
          dror_n(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r_n(i)/dy(3)
          i=i+1
         enddo
        endif
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Transition roches/glaces                                         c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        if (i.le.nb) then
         if (i.gt.1) j=j+1
         if (abs(mass_n(i)-mnoyau1).lt.abs(mass_n(i-1)-mnoyau1)) then
          idisc_n(j)=i
          y(1)=bp_n_S(nea*(i-1)*m_n_S+1)
          p_n(i)=exp(y(1))
          y(2)=1.d0
          y(3)=bp_n_S(nea*(i-1)*m_n_S+2)
          r_n(i)=sqrt(abs(y(3)))
          y(4)=0.d0
          y(5)=1.d0-mass_n(i)
          m_n(i)=sqrt(abs(mass_n(i)))**3
          call equations(2,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &         dtdsm,dy,ddy,ro_n(i),drop,drot,drom,
     &         etat,opa,conv,nuc)
         else
          idisc_n(j)=i-1
          p_n(i)=p_n(i-1)
          r_n(i)=r_n(i-1)
          m_n(i)=m_n(i-1)
          call equations(3,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &         dtdsm,dy,ddy,ro_n(i),drop,drot,drom,
     &         etat,opa,conv,nuc)
         endif
         dror_n(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r_n(i)/dy(3)
         
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Glaces                                                           c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         do while (i.le.nb)
          y(1)=bp_n_S(nea*(i-1)*m_n_S+1)
          p_n(i+j)=exp(y(1))
          y(2)=1.d0
          y(3)=bp_n_S(nea*(i-1)*m_n_S+2)
          r_n(i+j)=sqrt(abs(y(3)))
          y(4)=0.d0
          y(5)=1.d0-mass_n(i)
          m_n(i+j)=sqrt(abs(mass_n(i)))**3
          call equations(3,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &         dtdsm,dy,ddy,ro_n(i+j),drop,drot,drom,
     &         etat,opa,conv,nuc)
          dror_n(i+j)=(drop*dy(1)+drot*dy(2)+drom)*2*r_n(i+j)/dy(3)
          i=i+1
         enddo
        endif
        n_noy=nb+j
       endif
c       do i=1,n_noy
c        if (i.eq.idisc_n(1)) write(*,*)'-->Discontinuite i=',i
c        if ((i.eq.1).or.(i.eq.idisc_n(1)+1)) then
c         vdror=0.
c        else
c         vdror=(ro_n(i-1)-ro_n(i))/(r_n(i-1)-r_n(i))
c        endif
c        write(*,2000)m_n(i),r_n(i),p_n(i),0.,ro_n(i),dror_n(i),vdror,
c     &       drom
c       enddo
      else
       n_noy=0
      endif
c---------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Reconstruction du modele noyau+enveloppe dans m_d, r_d           c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      rplanet=r(1)
      ndis=1
      idisc(ndis)=1
      do i=1,nint(q_ppt(1))-1
       m_d(i)=m(i)
       r_d(i)=r(i)/rplanet
       p_d(i)=p(i)
       t_d(i)=t(i)
       l_d(i)=l(i)
       ro_d(i)=ro(i)
       dror_d(i)=dror(i)*rplanet
       chim_d(i)=chim(i)
      enddo
      j=0
      if (nint(q_ppt(1))-1.lt.n) then
       ndis=ndis+1
       idisc(ndis)=nint(q_ppt(1))+1
       i=nint(q_ppt(1))
       do j=1,2
        m_d(i+j-1)=m_dis(j)
        r_d(i+j-1)=r_dis(j)/rplanet
        p_d(i+j-1)=p_dis(j)
        t_d(i+j-1)=t_dis(j)
        l_d(i+j-1)=l_dis(j)
        ro_d(i+j-1)=ro_dis(j)
        dror_d(i+j-1)=dror_dis(j)*rplanet
        chim_d(i+j-1)=chim_dis(j)
       enddo
       j=1
       do i=nint(q_ppt(1))+1,n
        m_d(i+j)=m(i)
        r_d(i+j)=r(i)/rplanet
        p_d(i+j)=p(i)
        t_d(i+j)=t(i)
        l_d(i+j)=l(i)
        ro_d(i+j)=ro(i)
        dror_d(i+j)=dror(i)*rplanet
        chim_d(i+j)=chim(i)
       enddo
      endif
      n_d=n+j
      if (mnoyau.gt.0.) then
c On teste que Rnoyau <= Renveloppe
       if (r(n).lt.r_n(n_noy)) then
        write(*,*)'ATTENTION: r(n)<r_n(n_noy)!',r(n),r_n(n_noy)
        bid=r(n)/r_n(n_noy)*(1-1d-8)
        write(*,*)'Reajustement du rayon du noyau',bid
        do i=1,n_noy
         r_n(i)=r_n(i)*bid
        enddo
       endif
c-----------------
       do i=1,n_noy
        m_d(n_d+i)=m_n(n_noy-i+1)
        r_d(n_d+i)=r_n(n_noy-i+1)/rplanet
        p_d(n_d+i)=p_n(n_noy-i+1)
        t_d(n_d+i)=t_d(n_d)
        l_d(n_d+i)=l_d(n_d)
        ro_d(n_d+i)=ro_n(n_noy-i+1)
        dror_d(n_d+i)=dror_n(n_noy-i+1)*rplanet
        chim_d(n_d+i)=0.d0
       enddo
       ndis=ndis+1
       idisc(ndis)=n_d+1
       if (idisc_n(1).gt.0) then
        ndis=ndis+1
        idisc(ndis)=n_d+n_noy-idisc_n(1)+1
       endif
c       write(*,*)'r(i=',n_d,')=',r_d(n_d),' ro=',ro_d(n_d)
c       write(*,*)'r(i=',n_d+1,')=',r_d(n_d+1),' ro=',ro_d(n_d+1)
       r_d(n_d)=r_d(n_d+1)
       n_d=n_d+n_noy
      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Traitement des discontinuites.                                   c
c     Si delta Rho < 0, pas de calcul des moments                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do j=1,ndis
       if (j.eq.1) then
        deltaro(1)=ro_d(1)
       else
        deltaro(j)=ro_d(idisc(j))-ro_d(idisc(j)-1)
       endif
c       write(*,*)'-->discontinuite/i,deltaro',idisc(j),deltaro(j)
      enddo
c      write(*,888)ndis,(idisc(j),deltaro(j),j=1,ndis)
c 888  format(i2,' discontinuites:',<ndis>(' DRho(',i3,')=',1pd10.3))
      do j=1,ndis
       if (deltaro(j).lt.0.d0) then
        write(*,*)'PAS DE CALCUL DES MOMENTS GRAVITATIONNELS'
        pause
c        return
       endif
      enddo

      rplanet=rplanet*rjup

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Ecriture d'un fichier modele.bid                                 c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      open(unit=22,file='modele.bid',form='formatted',status='unknown')
c      write(22,2233)(idisc(j),deltaro(j),j=1,ndis)
c 2233 format('C *********** MODELE UTILISE DANS FIGURE ************',/,
c     &     'C Discontinuites:',t20,'Couche',t40,'DeltaRho [g/cm3]',/,
c     &     4('C',t21,i4,t42,1pd12.5,/))
c      write(22,*)'C  R, dRho/dR, Rho, M, Xchim, P, T'
c      write(22,*)n_d,rplanet
c      j=1
c      do i=n_d,1,-1
c       if (i.eq.idisc(j)) then
cc        write(*,*)'-->discontinuite/i,deltaro',i,deltaro(j)
c        j=j+1
c       endif
cc       if ((i.ne.1).and.(i.ne.n_d)) 
cc     &      vdror=(ro_d(i-1)-ro_d(i+1))/(r_d(i-1)-r_d(i+1))
c       write(22,2001)i,r_d(i),dror_d(i),ro_d(i),m_d(i),
c     &      chim_d(i),p_d(i),t_d(i)
c 2001  format(i3,7(1x,1pd12.5))
c      enddo
c      close(22)
c      write(*,*)'J''ai cree le fichier "modele.bid"'

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     VERIF est charge de tester que int(rho*4*pi*r^2 dr)=m            c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      call verif(mjup*mplanet,rplanet,m_d,r_d,ro_d,dror_d,
c     &     n_d,ndis,idisc,deltaro)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Appelle FIGURES2 (Theorie au 2eme ordre)                         c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      call figures2(mjup*mplanet,rplanet,omjup,m_d,r_d,ro_d,dror_d,
c     &     n_d,ndis,idisc,deltaro,a1,j2,j4,b,h)
c      write(*,*)
c      write(*,*)'a1,j2,j4:',a1,j2,j4

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Appelle FIGURES3 (Theorie au 3eme ordre)                         c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      call figures3(mjup*mplanet,rplanet,omjup,m_d,r_d,ro_d,dror_d,
c     &     n_d,ndis,idisc,deltaro,a1,j2,j4,j6,b,h)
c      write(*,*)
c      write(*,*)'a1,j2,j4,j6,j8:',a1,j2,j4,j6

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Appelle FIGURES4 (Theorie au 4eme ordre) ???????????             c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      call figures4(mjup*mplanet,rplanet,omjup,m_d,r_d,ro_d,dror_d,
     &     n_d,ndis,idisc,deltaro,a1,j2,j4,j6,j8,b,h)
c      write(*,*)
c      write(*,*)'a1,j2,j4,j6,j8:',a1,j2,j4,j6
      
      romoy=mjup*mplanet/(4/3.d0*pi*rplanet**3)
      mm=omjup**2*rplanet**3/g/mjup/mplanet
 200  format(i4,1x,7(1x,1pd10.3))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Construction d'un vecteur nodal en 1-r tenant compte des discontinuites
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      nd_f=0
      do i=1,n_d
       if (nd_f+2.le.ndis.and.i.eq.idisc(nd_f+2)) then
        nd_f=nd_f+1
        id_f(nd_f)=i-nd_f
        pot_fd(1,nd_f)=b(i)
        pot_fd(2,nd_f)=h(i)
       else
        x_f(i-nd_f)=10.d0-r_d(i)*(rplanet/rjup)
        pot_f(1,i-nd_f)=b(i)
        pot_f(2,i-nd_f)=h(i)
       endif
      enddo
      nx_f=n_d-nd_f

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     ecriture du fichier "potentiel.bid"                              c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      open(unit=23,file='potentiel.bid',form='formatted',
c     &     status='unknown')
c      do i=1,nx_f
c       write(23,2323)i,x_f(i),pot_f(1,i),pot_f(2,i)
c 2323  format(i4,1f12.8,1p,2d12.5)
c      enddo
c      write(23,*)'--Discontinuites--'
c      do i=1,nd_f
c       write(23,2323)id_f(i),x_f(id_f(i)),pot_fd(1,i),pot_fd(2,i)
c      enddo
c      write(23,*)'r_d,b,h'
c      do i=1,n_d
c       write(23,2323)i,r_d(i),b(i),h(i)
c      enddo
c      write(*,*)'J''ai cree le fichier "potentiel.bid"'
c      close(23)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     On spline le potentiel centrifuge                                c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      call pp_dis(2,x_f,pot_f,nd_f,id_f,pot_fd,nx_f,m_f,xt_f,xr_f,nr_f,
     &     knot_f,s_f)

c      open(unit=23,file='potentiel.bid',form='formatted',
c     &     status='unknown')
c      write(23,*)n_d
c      do i=1,n_d
c       xx=1.d0-r_d(i)*(rplanet/rjup)
c       call pp1dn(2,x_f,xt_f,xr_f,nx_f,nr_f,m_f,xx,knot_f,l,dfdx,
c     &      pot_f,s_f,fx,.true.)
cc       dfdx(1)=dfdx(1)*3*ro_d(i)/romoy*r_d(i)**3
cc       dfdx(2)=dfdx(2)*3*ro_d(i)/romoy*r_d(i)**3
c       dfdx(1)=dfdx(1)*(rplanet/rjup)
c       dfdx(2)=dfdx(2)*(rplanet/rjup)
c       if (i.ne.n_d) then
cc        write(23,200)i,r_d(i),m_d(i)/r_d(i)**3,2*mm/3,
cc     &       2*(b(i)-ro_d(i)*h(i)),
cc     &       r_d(i)*(-dfdx(1)+ro_d(i)*dfdx(2)),
cc     &       2*mm/3+2*(b(i)-ro_d(i)*h(i))+r_d(i)*(-dfdx(1)+
cc     &       ro_d(i)*dfdx(2)),ro_d(i)/ro_d(n_d)
c        write(23,200)i,r_d(i),m_d(i)/r_d(i)**3,2*mm/3,
c     &       2*(fx(1)-ro_d(i)*fx(2)),
c     &       r_d(i)*(-dfdx(1)+ro_d(i)*dfdx(2)),
c     &       2*mm/3+2*(fx(1)-ro_d(i)*fx(2))+r_d(i)*(-dfdx(1)+
c     &       ro_d(i)*dfdx(2)),ro_d(i)/ro_d(n_d)
c       else
c        write(23,200)i,r_d(i),ro_d(i)/romoy,2*mm/3,
c     &       2*(b(i)-ro_d(i)*h(i)),
c     &       r_d(i)*(-dfdx(1)+ro_d(i)*dfdx(2)),
c     &       2*mm/3+2*(b(i)-ro_d(i)*h(i))+r_d(i)*(-dfdx(1)+
c     &       ro_d(i)*dfdx(2)),ro_d(i)/ro_d(n_d)
c       endif
c      enddo
c      write(*,*)'J''ai cree le fichier "potentiel.bid"'
c      close(23)

      return
      end
