      
c**********************************************************************

      subroutine integre(m,n,k,x,f,l_der,dfdx1,dfdxn,ss)
c     Version: 02/12/99
c     Integration de x**k*f(x)
c Entrees: 
c     m: ordre des splines pour l'interpolation de f
c     n: nombre de points
c     k: moment de l'integrale
c     x(n): tableau des abscisses (croissant!!)
c     f(n): tableau de la fonction a interpoler (modifie)
c     l_der: si .true. l'interpolation se fait en tenant compte de dfdx1,n
c     dfdx1,dfdxn: derivees premieres en 1 et en n (si l_der=.true.)
c Sorties:
c     ss(n): ss(i)=int_x(1)^x(i){s**k * f(s) * ds}

      implicit none

      include './cepam.inc'
      integer pn_d,spx,pxt,dims
      parameter (pn_d=pn)
      parameter (spx=4,pxt=2*spx+pn_d,dims=pn_d*spx)

      integer m,n,k
      real*8 x(n),f(n),ss(n),dfdx1,dfdxn
      logical l_der

      integer i,nx,nrx,knotx,lx,l
      real*8 xt(pxt),xr(pn_d),s(dims)
      real*8 sss,dfdx,fx,fac

c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
c---- Test des dimensions
      if (n.gt.pn_d) then
       write(*,*)'INTEGRE: n=',n,'> pn_d=',pn_d
       pause
      endif
c------------------------

d      write(*,*)'INTEGRE: i,x(i),f(i)'
d      do i=1,n
d       write(*,*)i,x(i),f(i)
d      enddo
      sss=0.d0
      if (l_der) then
       call pp1dn_d(1,x,xt,xr,n,nrx,m,x(1),knotx,lx,dfdx,f,s,fx,
     &      .false.,dfdx1,dfdxn)
      else
       call pp1dn(1,x,xt,xr,n,nrx,m,x(1),knotx,lx,dfdx,f,s,fx,
     &      .false.)
      endif

      ss(1)=sss
      do i=2,n
       call slinf(x(i-1),xr,nrx,lx)
       fac=1.d0
       ss(i)=ss(i-1)
       do l=0,k
        call horper(m,m*(lx-1)+1,l,s,x(i-1)-xr(lx),x(i)-xr(lx),sss)
        ss(i)=ss(i)+sss*fac*xr(lx)**(k-l)
        fac=fac*(k-l)/(l+1.d0)
       enddo
      enddo

      return
      end
