      
c**********************************************************************

      subroutine integre_ss2(m,n,s,dros,ndis,idisc,s2,ss2,s4,ss4)
c     Version: 02/12/99
c     Integration de ss2, ss4
c Entrees: 
c     m: ordre des splines pour l'integration par INTEGRE
c     n: nombre de points
c     s(n): tableau des rayons
c     dros(n): dro/ds
c     ndis: nombre de discontinuites (dont la surface)
c     idisc(ndis): position des discontinuites
c     s2(n),s4(n)
c Sorties:
c     ss2(n),ss4(n): cf Zarkhov, Trubitsyn (S(beta))

      implicit none

      include './cepam.inc'
      integer pn_d,pn_dd
      parameter (pn_d=pn+pn_noy+pndis,pn_dd=pn+pn_noy)

      integer m,n,ndis,idisc(ndis)
      real*8 s(n),dros(n),s2(n),ss2(n),s4(n),ss4(n)

      integer i,nn,imax,j,h
      real*8 s_crois(pn_dd),u(pn_d,2),v(pn_dd,2),f2,x2,
     &     f4,x4,ssd(2),sss(pn_dd),ss(pn_d,2)

      
      f2(x2)=3/5.d0*x2+12/35.d0*x2**2
      f4(x2,x4)=18/35.d0*x2**2+1/3.d0*x4

c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
      do i=1,n
       u(i,1)=f2(s2(i))*dros(i)
       u(i,2)=f4(s2(i),s4(i))*dros(i)
      enddo

      ssd(1)=0.d0
      ssd(2)=0.d0
      imax=n

c     Renversement des fonctions et integration entre les discontinuites
      do j=ndis,1,-1
       if (j.ne.ndis) imax=idisc(j+1)-1
       do i=idisc(j),imax
        do h=1,2
         v(imax-i+1,h)=u(i,h)
        enddo
        s_crois(imax-i+1)=s(i)
       enddo
       nn=imax-idisc(j)+1
       do h=1,2
        call integre(m,nn,2*h+3,s_crois,v(1,h),.false.,0.d0,0.d0,sss)
        do i=1,nn
         ss(imax-i+1,h)=sss(i)+ssd(h)
        enddo
        ssd(h)=ss(idisc(j),h)
       enddo
      enddo

      do i=1,n
       ss2(i)=ss(i,1)
       ss4(i)=ss(i,2)
      enddo

      return
      end
