      
c**********************************************************************

      subroutine integre_ss3(m,n,s,dros,ndis,idisc,s2,ss2,s4,ss4,
     &     s6,ss6)
c     Version: 02/12/99
c     Integration de ss2, ss4, ss6
c Entrees: 
c     m: ordre des splines pour l'integration par INTEGRE
c     n: nombre de points
c     s(n): tableau des rayons
c     dros(n): dro/ds
c     ndis: nombre de discontinuites (dont la surface)
c     idisc(ndis): position des discontinuites
c     s2(n),s4(n),s6(n)
c Sorties:
c     ss2(n),ss4(n),ss6(n): cf Zarkhov, Trubitsyn (S(beta))

      implicit none

      include './cepam.inc'
      integer pn_d,pn_dd
      parameter (pn_d=pn+pn_noy+pndis,pn_dd=pn+pn_noy)

      integer m,n,ndis,idisc(ndis)
      real*8 s(n),dros(n),s2(n),ss2(n),s4(n),ss4(n),s6(n),ss6(n)

      integer i,nn,imax,j,h
      real*8 s_crois(pn_dd),u(pn_d,3),v(pn_dd,3),ssd(3),
     &     sss(pn_dd),ss(pn_d,3)
      real*8 f2,x2,f4,x4,f6,x6

      f2(x2,x4)=6/175.d0*x2**3+24/35.d0*x2*x4+12/35.d0*x2**2+3/5.d0*x2
      f4(x2,x4)=36/77.d0*x2**3+40/77.d0*x2*x4+18/35.d0*x2**2+1/3.d0*x4
      f6(x2,x4,x6)=72/143.d0*x2**3+120/143.d0*x2*x4+3/13.d0*x6

c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
      do i=1,n
       u(i,1)=f2(s2(i),s4(i))*dros(i)
       u(i,2)=f4(s2(i),s4(i))*dros(i)
       u(i,3)=f6(s2(i),s4(i),s6(i))*dros(i)
      enddo

      do h=1,3
       ssd(h)=0.d0
      enddo
      imax=n

c     Renversement des fonctions et integration entre les discontinuites
      do j=ndis,1,-1
       if (j.ne.ndis) imax=idisc(j+1)-1
       do i=idisc(j),imax
        do h=1,3
         v(imax-i+1,h)=u(i,h)
        enddo
        s_crois(imax-i+1)=s(i)
       enddo
       nn=imax-idisc(j)+1
       do h=1,3
        call integre(m,nn,2*h+3,s_crois,v(1,h),.false.,0.d0,0.d0,sss)
        do i=1,nn
         ss(imax-i+1,h)=sss(i)+ssd(h)
        enddo
        ssd(h)=ss(idisc(j),h)
       enddo
      enddo

      do i=1,n
       ss2(i)=ss(i,1)
       ss4(i)=ss(i,2)
       ss6(i)=ss(i,3)
      enddo

c$$$      open(unit=22,file='bid.dat',status='unknown')
c$$$      write(22,222)ndis,(idisc(i),i=1,5)
c$$$      do i=1,n
c$$$       write(22,223)i,s(i),ss2(i),ss4(i),ss6(i)
c$$$      enddo
c$$$ 222  format(1x,'ndis=',i4,/,1x,'idisc=',5(1x,i4),/)
c$$$ 223  format(1x,i3,1x,6(1pd12.5))
c$$$      close(22)
c      pause'INTEGRE_SS: pause'

      return
      end
