      
c**********************************************************************

      subroutine integre_ss4(m,n,s,dros,ndis,idisc,ss0,s2,ss2,s4,ss4,
     &     s6,ss6,s8,ss8)
c     Version: 02/12/99
c     Integration de ss0, ss2, ss4, ss6, ss8
c Entrees: 
c     m: ordre des splines pour l'integration par INTEGRE
c     n: nombre de points
c     s(n): tableau des rayons
c     dros(n): dro/ds
c     ndis: nombre de discontinuites (dont la surface)
c     idisc(ndis): position des discontinuites
c     s2(n),s4(n),s6(n),s8(n)
c Sorties:
c     ss0(n),ss2(n),ss4(n),ss6(n),ss8(n): cf Zarkhov, Trubitsyn (S(beta))

      implicit none

      include './cepam.inc'
      integer pn_d,pn_dd
      parameter (pn_d=pn+pn_noy+pndis,pn_dd=pn+pn_noy)

      integer m,n,ndis,idisc(ndis)
      real*8 s(n),dros(n),ss0(n),s2(n),ss2(n),s4(n),ss4(n),s6(n),ss6(n),
     &     s8(n),ss8(n)

      integer i,nn,imax,j,h
      real*8 s_crois(pn_dd),u(pn_d,0:4),v(pn_dd,0:4),ssd(0:4),
     &     sss(pn_dd),ss(pn_d,0:4)
      real*8 f0,f2,x2,f4,x4,f6,x6,f8,x8

      f0(x2)=-3/35.d0*x2**4
c      f0(x2)=0.d0
      f2(x2,x4)=3/5.d0*x2+12/35.d0*x2**2+6/175.d0*x2**3
     &     -184/1925.d0*x2**4
     &     +24/35.d0*x2*x4+216/385.d0*x2**2*x4+40/2321.d0*x4**2
      f4(x2,x4,x6)=18/35.d0*x2**2+36/77.d0*x2**3
     &     +486/5005.d0*x2**4+1/3.d0*x4
     &     +40/77.d0*x2*x4+6943/5005.d0*x2**2*x4+162/1001.d0*x4**2
     &     +90/143.d0*x2*x6
      f6(x2,x4,x6)=72/143.d0*x2**3+432/715.d0*x2**4+120/143.d0*x2*x4
     &     +216/143.d0*x2**2*x4+80/429.d0*x4**2+3/13.d0*x6
     &     +336/715.d0*x2*x6
      f8(x2,x4,x6,x8)=1296/2431.d0*x2**4+3780/2431.d0*x2**2*x4
     &     +2450/7293.d0*x4**2+168/221.d0*x2*x6+3/17.d0*x8

c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
      do i=1,n
c       u0(i)=f0(s2(i))*s(i)**3*dros(i)
c       u2(i)=f2(s2(i),s4(i))*s(i)**5*dros(i)
c       u4(i)=f4(s2(i),s4(i),s6(i))*s(i)**7*dros(i)
c       u6(i)=f6(s2(i),s4(i),s6(i))*s(i)**9*dros(i)
c       u8(i)=f8(s2(i),s4(i),s6(i),s8(i))*s(i)**11*dros(i)
       u(i,0)=f0(s2(i))*dros(i)
       u(i,1)=f2(s2(i),s4(i))*dros(i)
       u(i,2)=f4(s2(i),s4(i),s6(i))*dros(i)
       u(i,3)=f6(s2(i),s4(i),s6(i))*dros(i)
       u(i,4)=f8(s2(i),s4(i),s6(i),s8(i))*dros(i)
      enddo

      do h=0,4
       ssd(h)=0.d0
      enddo
      imax=n

c     Renversement des fonctions et integration entre les discontinuites
      do j=ndis,1,-1
       if (j.ne.ndis) imax=idisc(j+1)-1
       do i=idisc(j),imax
        do h=0,4
         v(imax-i+1,h)=u(i,h)
        enddo
        s_crois(imax-i+1)=s(i)
       enddo
       nn=imax-idisc(j)+1
       do h=0,4
        call integre(m,nn,2*h+3,s_crois,v(1,h),.false.,0.d0,0.d0,sss)
        do i=1,nn
         ss(imax-i+1,h)=sss(i)+ssd(h)
        enddo
        ssd(h)=ss(idisc(j),h)
       enddo
      enddo

      do i=1,n
       ss0(i)=ss(i,0)
       ss2(i)=ss(i,1)
       ss4(i)=ss(i,2)
       ss6(i)=ss(i,3)
       ss8(i)=ss(i,4)
      enddo

      open(unit=22,file='bid.dat',status='unknown')
      write(22,222)ndis,(idisc(i),i=1,5)
      write(22,*)n
      do i=1,n
       write(22,223)i,s(i),ss0(i),ss2(i),ss4(i),ss6(i),ss8(i)
      enddo
 222  format(1x,'ndis=',i4,/,1x,'idisc=',5(1x,i4),/)
 223  format(1x,i3,1x,6(1x,1pd12.5))
      close(22)
c      pause'INTEGRE_SS: pause'

      return
      end
