      
c**********************************************************************

      subroutine integre_tt2(m,n,s,dros,ndis,idisc,s2,tt2,s4,tt4)
c     Version: 02/12/99
c     Integration de tt2, tt4
c Entrees: 
c     m: ordre des splines pour l'integration par INTEGRE
c     n: nombre de points
c     s(n): tableau des rayons
c     dros(n): dro/ds
c     ndis: nombre de discontinuites (dont la surface)
c     idisc(ndis): position des discontinuites
c     s2(n),s4(n)
c Sorties:
c     tt2(n),tt4(n): cf Zarkhov, Trubitsyn (S'(beta))

      implicit none

      include './cepam.inc'
      integer pn_d,pn_dd
      parameter (pn_d=pn+pn_noy+pndis,pn_dd=pn+pn_noy)

      integer m,n,ndis,idisc(ndis)
      real*8 s(n),dros(n),s2(n),tt2(n),s4(n),tt4(n)

      integer i,nn,imax,j,h
      real*8 s_crois(pn_dd),u(pn_d,2),v(pn_dd,2),g2,x2,
     &     g4,x4,ssd(2),sss(pn_dd),ss(pn_d,2)

      
      g2(x2)=3/5.d0*x2-3/35.d0*x2**2
      g4(x2,x4)=-9/35.d0*x2**2+1/3.d0*x4

c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
      do i=1,n-1
       u(i,1)=g2(s2(i))*dros(i)
       u(i,2)=g4(s2(i),s4(i))/s(i)**2*dros(i)
      enddo
      u(n,1)=g2(s2(n))*dros(n)
      u(n,2)=g4(s2(n),s4(n))/s(n-1)**2/100.d0*dros(n)

      ssd(1)=0.d0
      ssd(2)=0.d0

c     Renversement des fonctions et integration entre les discontinuites
      do j=1,ndis
       if (j.eq.ndis) then
        imax=n
       else
        imax=idisc(j+1)-1
       endif
       do i=idisc(j),imax
        do h=1,2
         v(i-idisc(j)+1,h)=u(i,h)
        enddo
        s_crois(i-idisc(j)+1)=-s(i)
       enddo
       nn=imax-idisc(j)+1
       do h=1,2
        call integre(m,nn,0,s_crois,v(1,h),.false.,0.d0,0.d0,sss)
        do i=1,nn
         ss(i+idisc(j)-1,h)=sss(i)+ssd(h)
        enddo
        ssd(h)=ss(imax,h)
       enddo
      enddo

      do i=1,n
       tt2(i)=ss(i,1)
       tt4(i)=ss(i,2)
      enddo

c      open(unit=22,file='bid.dat',status='unknown')
c      write(22,222)ndis,(idisc(i),i=1,5)
c      do i=1,n
c       write(22,223)i,s(i),v2(i),v4(i),tt2(i),tt4(i)
c      enddo
c 222  format(1x,'ndis=',i4,/,1x,'idisc=',5(1x,i4),/)
c 223  format(1x,i3,5(1x,1pd12.5))
c      close(22)
c      pause'INTEGRE_TT: pause'

      return
      end
