      
c**********************************************************************

      subroutine integre_tt4(m,n,s,dros,ndis,idisc,s2,tt2,s4,tt4,
     &     s6,tt6,s8,tt8)
c     Version: 02/12/99
c     Integration de tt2, tt4, tt6, tt8
c Entrees: 
c     m: ordre des splines pour l'integration par INTEGRE
c     n: nombre de points
c     s(n): tableau des rayons
c     dros(n): dro/ds
c     ndis: nombre de discontinuites (dont la surface)
c     idisc(ndis): position des discontinuites
c     s2(n),s4(n),s6(n),s8(n)
c Sorties:
c     tt2(n),tt4(n),tt6(n),tt8(n): cf Zarkhov, Trubitsyn (S'(beta))

      implicit none

      include './cepam.inc'
      integer pn_d,pn_dd
      parameter (pn_d=pn+pn_noy+pndis,pn_dd=pn+pn_noy)

      integer m,n,ndis,idisc(ndis)
      real*8 s(n),dros(n),s2(n),tt2(n),s4(n),tt4(n),s6(n),tt6(n),
     &     s8(n),tt8(n)

      integer i,nn,imax,j,h
      real*8 s_crois(pn_dd),u(pn_d,4),v(pn_dd,4),ssd(4),
     &     sss(pn_dd),ss(pn_d,4)
      real*8 g2,x2,g4,x4,g6,x6,g8,x8

      g2(x2,x4)=3/5.d0*x2-3/35.d0*x2**2+36/175.d0*x2**3-17/275.d0*x2**4
     &     -6/35.d0*x2*x4+36/385.d0*x2**2*x4-10/231.d0*x4**2
      g4(x2,x4,x6)=-9/35.d0*x2**2+72/385.d0*x2**3
     &     +1062/2275.d0*x2**4+1/3.d0*x4
     &     -20/77.d0*x2*x4+4579/5005.d0*x2**2*x4-81/1001.d0*x4**2
     &     -45/143.d0*x2*x6
      g6(x2,x4,x6)=270/1001.d0*x2**3-54/143.d0*x2**4-75/143.d0*x2*x4
     &     +810/1001.d0*x2**2*x4-50/429.d0*x4**2+3/13.d0*x6
     &     -42/143.d0*x2*x6
      g8(x2,x4,x6,x8)=-4536/12155.d0*x2**4+2352/2431.d0*x2**2*x4
     &     -1715/7293.d0*x4**2-588/1105.d0*x2*x6+3/17.d0*x8

c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
      do i=1,n-1
       u(i,1)=g2(s2(i),s4(i))*dros(i)
       u(i,2)=g4(s2(i),s4(i),s6(i))/s(i)**2*dros(i)
       u(i,3)=g6(s2(i),s4(i),s6(i))/s(i)**4*dros(i)
       u(i,4)=g8(s2(i),s4(i),s6(i),s8(i))/s(i)**6*dros(i)
      enddo
      u(n,1)=g2(s2(n),s4(n))*dros(n)
      u(n,2)=g4(s2(n),s4(n),s6(n))/(s(n-1)/10.d0)**2*dros(n)
      u(n,3)=g6(s2(n),s4(n),s6(n))/(s(n-1)/10.d0)**4*dros(n)
      u(n,4)=g8(s2(n),s4(n),s6(n),s8(n))/(s(n-1)/10.d0)**6*dros(n)

      do h=1,4
       ssd(h)=0.d0
      enddo

c     Renversement des fonctions et integration entre les discontinuites
      do j=1,ndis
       if (j.eq.ndis) then
        imax=n
       else
        imax=idisc(j+1)-1
       endif
       do i=idisc(j),imax
        do h=1,4
         v(i-idisc(j)+1,h)=u(i,h)
        enddo
        s_crois(i-idisc(j)+1)=-s(i)
       enddo
       nn=imax-idisc(j)+1
       do h=1,4
        call integre(m,nn,0,s_crois,v(1,h),.false.,0.d0,0.d0,sss)
        do i=1,nn
         ss(i+idisc(j)-1,h)=sss(i)+ssd(h)
        enddo
        ssd(h)=ss(imax,h)
       enddo
      enddo

      do i=1,n
       tt2(i)=ss(i,1)
       tt4(i)=ss(i,2)
       tt6(i)=ss(i,3)
       tt8(i)=ss(i,4)
      enddo

c      open(unit=22,file='bid1.dat',status='unknown')
c      write(22,222)ndis,(idisc(i),i=1,5)
c      do i=1,n
c       write(22,223)i,s(i),tt2(i),tt4(i),tt6(i),tt8(i)
c      enddo
c 222  format(1x,'ndis=',i4,/,1x,'idisc=',5(1x,i4),/)
c 223  format(1x,i3,1x,6(1pd12.5))
c      close(22)
c      pause'INTEGRE_TT: pause'

      return
      end
