c**********************************************************************

      subroutine figures(bp_S,q,qt_S,knot_S,
     &     m_tc,mt_tc,mr_tc,n_tc,nr_tc,knot_tc,xchims_tc,q_ppt,
     &     a1,j2,j4,j6,j8)
c     Version: 16/06/2003
c-Entrees:
c     bp_S,q,qt_S,knot_S: coefficients de splines caracterisant le modele
c     m_tc,mt_tc,mr_tc,n_tc,nr_tc,knot_tc,xchims_tc: coefficients de spline
c         pour calcul de la composition chimique
c     q_ppt(2): position de la ppt (q_ppt(1)<q_ppt<q_ppt(2))
c     splines pour la composition chimique
c-Sorties:
c     a1: rayon equatorial
c     j2,j4,j6,j8: moments gravitationnels 
c     COMMON(s) /figures_i/ et /figures_r/: contiennent les coefficients
c     de spline pour le calcul du potentiel centrifuge d'ordre >0
c     (utilise dans EQUATIONS)
c Note: ce COMMON inclue la variable rplanet qui est recalculee ici
      
      implicit none
      
      include './cepam.inc'
      integer pspl,pjac,pspl_n,pjac_n,pdxt_n,pn_d,pn_f
      parameter (pspl=pm_S*(pn-1)+pr_S, pjac=pne*pspl,
     &     pspl_n=pm_S*(pn_noy-1)+1, pjac_n=pne_noy*pspl_n,
     &     pdxt_n=pm_S*pn_noy+2*pr_S, pn_d=pn+pn_noy+pndis,
     &     pn_f=pn+pn_noy)
      
      integer knot_S,n_tc,nr_tc,knot_tc,nea
      real*8 bp_S(pjac),q(pn),qt_S(pn),m_tc(1),mt_tc(1),mr_tc(1),
     &     xchims_tc(1),q_ppt(2)
      
      integer nd_f,nx_f,m_f,nr_f,knot_f,id_f(0:pndis+1)
      real*8 x_f(pn_f),xt_f(pn_f+pmc_S*(pndis+2)),xr_f(pn_f),
     &     s_f(pn_d*pmc_S*2),pot_f(2,pn_d),
     &     pot_fd(2,pndis),rplanet
      common/figures_i/nd_f,nx_f,m_f,nr_f,knot_f,id_f
      common/figures_r/x_f,xt_f,xr_f,pot_f,s_f,rplanet
      data m_f/3/
      
      integer i,j,ll,idisc_n(pndis),idisc(pndis),n_d,n_noy,ndis,nbrock,
     &     ierr
      real*8 p(pn),t(pn),r(pn),l(pn),m(pn),mu(pn),xchim(pnelem),
     &     dxchim(pnelem),dxchimm(pnelem),lnp_S(pspl),lnt_S(pspl),
     &     r2_S(pspl),l23_S(pspl),mu_S(pspl),y(5),dy(5),ddy(5,5),
     &     ro(pn),dror(pn),chim(pn),chim_dis(pndis),
     &     p_dis(pndis),t_dis(pndis),r_dis(pndis),
     &     l_dis(pndis),m_dis(pndis),ro_dis(pndis),dror_dis(pndis),
     &     p_n(pn_noy),r_n(pn_noy),m_n(pn_noy),ro_n(pn_noy),
     &     t_n(pn_noy),drop_n(pn_noy),dror_n(pn_noy),deltaro(pndis),
     &     m_d(pn_d),r_d(pn_d),p_d(pn_d),t_d(pn_d),l_d(pn_d),ro_d(pn_d),
     &     dror_d(pn_d),b(pn_d),h(pn_d),unpdx(2),chim_d(pn_d)
      real*8 drop,drot,drom,tds,dtdsp,dtdst,dtdsl,dtdsm,mm,r_rac,drdp,
     &     bid,a1,j2,j4,j6,j8,romoy,rnoy,vdror,rtot,mui

c Pour interpolation du pot. grav
      integer lx
      real*8 xx,fx(2),dfdx(2)

      integer*4 leng
      real*8 interq
      
      include './Communs/ctephys.inc'
      include './Communs/planetes.inc'
      include './Communs/modelp.inc'
      
c...........S.............A...........V..............E..................
      save 
c-----------------------------------------------------------------------
 2000 format(1p8d10.3)
      
      unpdx(1)=1.d0-1.d-5
      unpdx(2)=1.d0+1.d-5
      tds=0.
      dtdsp=0.
      dtdsl=0.
      dtdsm=0.

c     write(*,*)'FIGURES: m,r,p,t,ro,dror,dror(lineaire)'

c---- Recuperation de l'enveloppe ----------------------------------      
      do i=1,n
       y(1)=bp_S(neqs*(i-1)*m_S+1)
       p(i)=exp(y(1))
       y(2)=bp_S(neqs*(i-1)*m_S+2)
       t(i)=exp(y(2))
       if(en_masse)then
        y(3)=bp_S(neqs*(i-1)*m_S+3)
        r(i)=sqrt(abs(y(3)))
        y(4)=bp_S(neqs*(i-1)*m_S+4)
        l(i)=sqrt(abs(y(4)))**3
        y(5)=bp_S(neqs*(i-1)*m_S+5)
        mu(i)=y(5)             !mu=(1-masse**2/3) au point courant
        m(i)=sqrt(abs(1.d0-y(5)))**3
       else
        pause 'revoir le modele en rayon'
        y(3)=bp_S(neqs*(i-1)*m_S+3)
        r(i)=y(3)
        y(4)=bp_S(neqs*(i-1)*m_S+4)
        l(i)=y(4)
        y(5)=bp_S(neqs*(i-1)*m_S+5)
        mu(i)=y(5)
        m(i)=y(5)
       endif
       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Composition chimique                                             c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       call pp1dn(nbelem,m_tc,mt_tc,mr_tc,n_tc,nr_tc,mc_S,mu(i),
     &      knot_tc,ll,dxchim,bid,xchims_tc,xchim,.true.)
       do j=1,nbelem
c        xchim(j)=xchim(j)*nucleo(j)
        dxchimm(j)=-dxchim(j)
       enddo
       chim(i)=xchim(1)
       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Pour eviter le probleme au centre lorsque Mnoyau=0               c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if ((y(3).le.0.).or.(y(5).ge.1.d0)) then
        y(3)=1d-6
        y(5)=1-sqrt(4/3.d0*pi*ro(i-1))**3*y(3)
       endif
       
       call equations(0,y,xchim,dxchimm,.false.,tds,dtdsp,dtdst,
     &      dtdsm,dy,ddy,ro(i),drop,drot,drom)
       
       dror(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r(i)/dy(3)
c       if (i.gt.1) vdror=(ro(i-1)-ro(i))/(r(i-1)-r(i))

c       write(*,2000)m(i),r(i),p(i),t(i),ro(i),dror(i),vdror,drom
      enddo
      
c      write(*,*)'FIGURES: rjup=',rjup,' r(1)=',r(1)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c---- Si PPT recherche de la transition ----------------------------   c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (ppt) then
       do i=1,(n-1)*m_S+r_S     !modele au temps t
        lnp_S(i)=bp_S(neqs*(i-1)+1)
        lnt_S(i)=bp_S(neqs*(i-1)+2)
        r2_S(i) =bp_S(neqs*(i-1)+3)
        l23_S(i)=bp_S(neqs*(i-1)+4)
        mu_S(i)=bp_S(neqs*(i-1)+5)
       enddo
       
       if (silent.le.0) write(*,*)'Localisation PPT: ',
     &      q_ppt(1),'< q_ppt < ',q_ppt(2)
c       call dis_ppt(lnp_S,lnt_S,q,qt_S,m_S,r_S,knot_S,n,q_ppt(1)
c     &      ,q_ppt(2))
c       write(*,*)'Localisation PPT: ',q_ppt(1),'< q_ppt < ',q_ppt(2)
       
       do i=1,2
        y(1)=interq(lnp_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
     &       +(2*i-3)*1.d-3
        p_dis(i)=exp(y(1))
        y(2)=interq(lnt_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        t_dis(i)=exp(y(2))
        y(3)=interq(r2_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        r_dis(i)=sqrt(abs(y(3)))
        y(4)=interq(l23_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        l_dis(i)=sqrt(abs(y(4)))**3
        y(5)=interq(mu_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i),n)
        m_dis(i)=sqrt(abs(1.d0-y(5)))**3

c     On utilise la table de composition splinee en se placant aux couches
c     q_ppt-1 et q_ppt+1 afin d'eviter tout probleme.
        mui=interq(mu_S,q,qt_S,m_S,r_S,knot_S,q_ppt(i)-1+2*(i-1),n)
        call pp1dn(nbelem,m_tc,mt_tc,mr_tc,n_tc,nr_tc,mc_S,
     &       mui,
     &       knot_tc,ll,dxchim,bid,xchims_tc,xchim,.true.)
        chim_dis(i)=xchim(1)
c        write(*,*)'FIGURES: chim=',chim_dis(i)
        
        call equations(0,y,xchim,dxchimm,.true.,tds,dtdsp,dtdst,
     &       dtdsm,dy,ddy,ro_dis(i),drop,drot,drom)
        
        dror_dis(i)=(drop*dy(1)+drot*dy(2)+drom)*2*r_dis(i)/dy(3)
        
c        write(*,*)'PPT:'
c        write(*,2000)m_dis(i),r_dis(i),p_dis(i),t_dis(i),ro_dis(i),
c     &       dror_dis(i),drom
c        write(*,*)
       enddo
       r_dis(1)=r_dis(2)
      else
       q_ppt(1)=dble(n+1)
      endif                     !PPT

c      write(*,*)'q_ppt',q_ppt(1)
c      do i=1,n
c       write(*,'(i3,1p,3d14.7)')i,m(i),p(i),ro(i)
c      enddo
c      pause

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c---- Reconstruction du noyau ---------------------------------------  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (mnoyau.ne.0.) then
       call lim_noyau(.true.,2,p(n),r_rac,drdp,p_n,t_n,ro_n,r_n,m_n,
     &      drop_n,dror_n,n_noy)
c       do i=1,n_noy
c        write(*,'(i3,1p,4d14.7)')i,m_n(i),p_n(i),ro_n(i),dror_n(i)
c       enddo
       j=0
       idisc_n(1)=0
       if ((p_ice.gt.1.d-8).and.(1.d0-p_ice.gt.1.d-8)) then
        j=j+1
        nbrock=nint((n_noy-1)*(1.d0-p_ice))
        nbrock=max(10,nbrock)
        nbrock=min(n_noy-1-10,nbrock)
        idisc_n(j)=nbrock
       endif
      else
       n_noy=0
      endif
c---------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Reconstruction du modele noyau+enveloppe dans m_d, r_d           c
c     Attention: on reajuste le modele pour avoir r variant de 0 a 1   c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      rtot=r(1)                 !rayon adimensionne du modele
      rplanet=rtot*rjup         !rayon physique du modele (DANS COMMON)

      ndis=1
      idisc(ndis)=1
      do i=1,nint(q_ppt(1))-1
       m_d(i)=m(i)
       r_d(i)=r(i)/rtot
       p_d(i)=p(i)
       t_d(i)=t(i)
       l_d(i)=l(i)
       ro_d(i)=ro(i)
       dror_d(i)=dror(i)*rtot
       chim_d(i)=chim(i)
      enddo
      j=0
      if (nint(q_ppt(1))-1.lt.n) then
       ndis=ndis+1
       idisc(ndis)=nint(q_ppt(1))+1
       i=nint(q_ppt(1))
       do j=1,2
        m_d(i+j-1)=m_dis(j)
        r_d(i+j-1)=r_dis(j)/rtot
        p_d(i+j-1)=p_dis(j)
        t_d(i+j-1)=t_dis(j)
        l_d(i+j-1)=l_dis(j)
        ro_d(i+j-1)=ro_dis(j)
        dror_d(i+j-1)=dror_dis(j)*rtot
        chim_d(i+j-1)=chim_dis(j)
       enddo
       j=1
       do i=nint(q_ppt(1))+1,n
        m_d(i+j)=m(i)
        r_d(i+j)=r(i)/rtot
        p_d(i+j)=p(i)
        t_d(i+j)=t(i)
        l_d(i+j)=l(i)
        ro_d(i+j)=ro(i)
        dror_d(i+j)=dror(i)*rtot
        chim_d(i+j)=chim(i)
       enddo
      endif
      n_d=n+j
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     On ajoute le noyau.                                              c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if ((mnoyau.gt.0.).and.(m(n).gt.0)) then
       do i=1,n_noy
        m_d(n_d+i)=m_n(n_noy-i+1)
        r_d(n_d+i)=r_n(n_noy-i+1)/rtot
        p_d(n_d+i)=p_n(n_noy-i+1)
        t_d(n_d+i)=t_d(n_d)
        l_d(n_d+i)=l_d(n_d)
        ro_d(n_d+i)=ro_n(n_noy-i+1)
        dror_d(n_d+i)=dror_n(n_noy-i+1)*rtot
        chim_d(n_d+i)=0.d0
       enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     On teste les problemes de raccord (lorsque l'on modifie Mnoyau)  c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       if (r(n-1).lt.r_n(n_noy)) then
        bid=(r_n(n_noy)-r(n))/(r_n(n_noy)+r(n))*2.
        write(*,666)r(n),r_n(n_noy),bid
        write(*,667)
 666     format('ATTENTION: r(n)=',f12.8,'< r_n(n_noy)=',f12.8,
     &        '; Reajustement du rayon du noyau: ',1p,d10.3)
 667    format('CHANGEMENT TROP BRUSQUE: NOYAU A DENSITE CONSTANTE ')
        write(*,*)m(n),m_n(n_noy)
        romoy=3*m(n)*mplanet*mjup/4/pi/(r(n)*rjup)**3
        do i=1,n_noy
         m_d(n_d+i)=m_n(n_noy-i+1)*m(n)/m_n(n_noy)
         ro_d(n_d+i)=romoy
         dror_d(n_d+i)=0.d0
         r_d(n_d+i)=(3*m_d(n_d+i)*mplanet*mjup/4/pi/romoy)**(1/3.d0)
     &        /rjup/rtot
        enddo
c        if (silent.lt.2) write(*,666)r(n),r_n(n_noy),bid
c         rnoy=r_n(n_noy)+1d-12
c         do i=1,n_d
c          bid=r_d(i)            !ancien rayon (VT)
c          r_d(i)=rnoy+(r_d(i)-r(n))*(r(1)-rnoy)/(r(1)-r(n))
c          ro_d(i)=ro_d(i)*(bid/r_d(i))**3 !pour conservation de la masse (~)
c         enddo
c        endif
       endif
c-----------------
       ndis=ndis+1
       idisc(ndis)=n_d+1
       if (idisc_n(1).gt.0) then
        ndis=ndis+1
        idisc(ndis)=n_d+n_noy-idisc_n(1)+1
       endif
c       write(*,*)'r(i=',n_d,')=',r_d(n_d),' ro=',ro_d(n_d)
c       write(*,*)'r(i=',n_d+1,')=',r_d(n_d+1),' ro=',ro_d(n_d+1)
       r_d(n_d)=r_d(n_d+1)
       n_d=n_d+n_noy
      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Test: monotonie des rayons (superflu?)                           c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ierr=0
      do i=2,n_d
       if (r_d(i).gt.r_d(i-1)) then
        ierr=2
        write(*,567)i-1,r_d(i-1),ro_d(i-1),i,r_d(i),ro_d(i)
 567    format('FIGURE: Probleme de monotonie de R:',/,
     &       2(2x,'i=',i4,' r=',f12.8,' ro=',1p,d14.7,/))
       endif
      enddo
c Si pb, on garde le dernier potentiel gravitationnel
      if (ierr.eq.2) then
       if (silent.eq.0) then
        write(*,*)'i R M Rho dRho/dR'
        do i=1,n_d
         write(*,'(i4,1p,4d14.7)')i,r_d(i),m_d(i),ro_d(i),dror_d(i)
        enddo
       endif
       return
      endif
C       bid=0.
C      endif
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Traitement des discontinuites.                                   c
c     Si delta Rho < 0, pas de calcul des moments                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do j=1,ndis
       if (j.eq.1) then
        deltaro(1)=ro_d(1)
       else
        deltaro(j)=ro_d(idisc(j))-ro_d(idisc(j)-1)
       endif
       if (silent.eq.0)
     &      write(*,*)'-->discontinuite/i,deltaro',idisc(j),deltaro(j)
      enddo
      if (silent.le.0)
     &     write(*,888)ndis,(idisc(j),deltaro(j),j=1,ndis)
 888  format(i2,' discontinuites:',4(' DRho(',i3,')=',1pd10.3))
      do j=1,ndis
       if (deltaro(j).lt.0.d0) then
        write(*,*)'PAS DE CALCUL DES MOMENTS GRAVITATIONNELS'
        pause
c        return
       endif
      enddo

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Ecriture d'un fichier modele.bid                                 c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (silent.lt.0) then
       open(unit=22,file='modele.bid',form='formatted',status='unknown')
       write(22,2233)(idisc(j),deltaro(j),j=1,ndis)
 2233  format('C *********** MODELE UTILISE DANS FIGURE ************',/,
     &      'C Discontinuites:',t20,'Couche',t40,'DeltaRho [g/cm3]',/,
     &      4('C',t21,i4,t42,1pd12.5,/))
       write(22,*)'C  R, dRho/dR, Rho, M, Xchim, P, T'
       write(22,*)n_d,rplanet
       j=1
       do i=1,n_d
        if (i.eq.idisc(j)) then
         write(*,*)'-->discontinuite/i,deltaro',i,deltaro(j)
         j=j+1
        endif
        if ((i.ne.1).and.(i.ne.n_d)) 
     &       vdror=(ro_d(i-1)-ro_d(i+1))/(r_d(i-1)-r_d(i+1))
        write(22,2001)i,r_d(i),dror_d(i),ro_d(i),m_d(i),
     &       chim_d(i),p_d(i),t_d(i)
 2001   format(i3,7(1x,1pd12.5))
       enddo
       close(22)
       write(*,*)'J''ai cree le fichier "modele.bid"'
      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     VERIF est charge de tester que int(rho*4*pi*r^2 dr)=m            c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      call verif(mjup*mplanet,rplanet,m_d,r_d,ro_d,dror_d,
c     &     n_d,ndis,idisc,deltaro)

      if (f_rot(:leng(f_rot)).eq.'figures2') then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Appelle FIGURES2 (Theorie au 2eme ordre)                         c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       call figures2(mjup*mplanet,rplanet,omega*omjup,m_d,r_d,ro_d,
     &      dror_d,n_d,ndis,idisc,deltaro,a1,j2,j4,b,h,ierr)
c      write(*,*)
c      write(*,*)'a1,j2,j4:',a1,j2,j4
      elseif (f_rot(:leng(f_rot)).eq.'figures3') then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Appelle FIGURES3 (Theorie au 3eme ordre)                         c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       call figures3(mjup*mplanet,rplanet,omega*omjup,m_d,r_d,ro_d,
     &      dror_d,n_d,ndis,idisc,deltaro,a1,j2,j4,j6,b,h,ierr)
c      write(*,*)
c      write(*,*)'a1,j2,j4,j6,j8:',a1,j2,j4,j6
      elseif (f_rot(:leng(f_rot)).eq.'figures4') then
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Appelle FIGURES4 (Theorie au 4eme ordre) ???????????             c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       call figures4(mjup*mplanet,rplanet,omega*omjup,m_d,r_d,ro_d
     &      ,dror_d,n_d,ndis,idisc,deltaro,a1,j2,j4,j6,j8,b,h,ierr)
c      write(*,*)
c      write(*,*)'a1,j2,j4,j6,j8:',a1,j2,j4,j6
      else
       write(*,22)f_rot(:leng(f_rot))
 22    format(/,70('!'),/,'FIGURES:',/,'La subroutine ',a,
     &      ' n''est pas implementee',/,
     &      'PAS DE CALCUL DES MOMENTS GRAVITATIONNELS')
       return
      endif

      if (ierr.ne.0) return

      romoy=mjup*mplanet/(4/3.d0*pi*rplanet**3)
      mm=omega*omjup**2*rplanet**3/g/mjup/mplanet
 200  format(i4,1x,7(1x,1pd10.3))

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Construction d'un vecteur nodal en mu tenant compte des discontinuites
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      nd_f=0
      do i=1,n_d
       if (nd_f+2.le.ndis.and.i.eq.idisc(nd_f+2)) then
        nd_f=nd_f+1
        id_f(nd_f)=i-nd_f
        pot_fd(1,nd_f)=b(i)
        pot_fd(2,nd_f)=h(i)
       else
c        x_f(i-nd_f)=1.d0-r_d(i)*(rplanet/rjup)
        x_f(i-nd_f)=1.d0-m_d(i)
        pot_f(1,i-nd_f)=b(i)
        pot_f(2,i-nd_f)=h(i)
       endif
      enddo
      nx_f=n_d-nd_f

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     ecriture du fichier "potentiel.bid"                              c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (silent.lt.0) then
       open(unit=23,file='potentiel.bid',form='formatted',
     &      status='unknown')
       write(23,*)'mu,b,h'
       do i=1,nx_f
        write(23,2323)i,x_f(i),pot_f(1,i),pot_f(2,i)
 2323   format(i4,1f12.8,1p,2d12.5)
       enddo
       write(23,*)'--Discontinuites: ',nd_f
       do i=1,nd_f
        write(23,2323)id_f(i),x_f(id_f(i)),pot_fd(1,i),pot_fd(2,i)
       enddo
       write(23,*)'m_d,b,h'
       do i=1,n_d
        write(23,2323)i,m_d(i),b(i),h(i)
       enddo
       write(*,*)'J''ai cree le fichier "potentiel.bid"'
       close(23)
      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     On spline le potentiel centrifuge                                c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (nd_f.gt.0) then
c Avec discontinuites
       call pp_dis(2,x_f,pot_f,nd_f,id_f,pot_fd,nx_f,m_f,xt_f,xr_f,nr_f,
     &      knot_f,s_f)
      else
c Sans discontinuites
       xx=x_f(1)
       call pp1dn(2,x_f,xt_f,xr_f,nx_f,nr_f,m_f,xx,knot_f,lx,dfdx,pot_f,
     &     s_f,fx,.false.)
      endif

c      open(unit=23,file='potentiel.bid',form='formatted',
c     &     status='unknown')
c      write(23,*)n_d
c      do i=1,n_d
c       xx=1.d0-r_d(i)*(rplanet/rjup)
c       call pp1dn(2,x_f,xt_f,xr_f,nx_f,nr_f,m_f,xx,knot_f,lx,dfdx,
c     &      pot_f,s_f,fx,.true.)
cc       dfdx(1)=dfdx(1)*3*ro_d(i)/romoy*r_d(i)**3
cc       dfdx(2)=dfdx(2)*3*ro_d(i)/romoy*r_d(i)**3
c       dfdx(1)=dfdx(1)*(rplanet/rjup)
c       dfdx(2)=dfdx(2)*(rplanet/rjup)
c       if (i.ne.n_d) then
cc        write(23,200)i,r_d(i),m_d(i)/r_d(i)**3,2*mm/3,
cc     &       2*(b(i)-ro_d(i)*h(i)),
cc     &       r_d(i)*(-dfdx(1)+ro_d(i)*dfdx(2)),
cc     &       2*mm/3+2*(b(i)-ro_d(i)*h(i))+r_d(i)*(-dfdx(1)+
cc     &       ro_d(i)*dfdx(2)),ro_d(i)/ro_d(n_d)
c        write(23,200)i,r_d(i),m_d(i)/r_d(i)**3,2*mm/3,
c     &       2*(fx(1)-ro_d(i)*fx(2)),
c     &       r_d(i)*(-dfdx(1)+ro_d(i)*dfdx(2)),
c     &       2*mm/3+2*(fx(1)-ro_d(i)*fx(2))+r_d(i)*(-dfdx(1)+
c     &       ro_d(i)*dfdx(2)),ro_d(i)/ro_d(n_d)
c       else
c        write(23,200)i,r_d(i),ro_d(i)/romoy,2*mm/3,
c     &       2*(b(i)-ro_d(i)*h(i)),
c     &       r_d(i)*(-dfdx(1)+ro_d(i)*dfdx(2)),
c     &       2*mm/3+2*(b(i)-ro_d(i)*h(i))+r_d(i)*(-dfdx(1)+
c     &       ro_d(i)*dfdx(2)),ro_d(i)/ro_d(n_d)
c       endif
c      enddo
c      write(*,*)'J''ai cree le fichier "potentiel.bid"'
c      close(23)

      return
      end
